package ctbrec.ui.sites.streamate;

import ctbrec.Config;
import ctbrec.sites.streamate.Streamate;
import ctbrec.ui.sites.AbstractTabProvider;
import ctbrec.ui.tabs.ThumbOverviewTab;
import javafx.scene.Scene;
import javafx.scene.control.Tab;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class StreamateTabProvider extends AbstractTabProvider {
    private ThumbOverviewTab followedTab;

    public StreamateTabProvider(Streamate streamate) {
        super(streamate);
    }

    @Override
    protected List<Tab> getSiteTabs(Scene scene) {
        List<Tab> tabs = new ArrayList<>();


        Map<String, String> tabMap = new HashMap<>();
        tabMap.put("f,ff", "Girls");
        tabMap.put("m", "Guys");
        tabMap.put("mf,mm", "Couples");
        tabMap.put("tm2f,tf2m", "Trans");
        tabMap.put("fn", "Girls New");
        tabMap.put("new", "New");
        List<String> enabledTabs = getEnabledTabs();
        for (String tab : enabledTabs) {
            String title = tabMap.getOrDefault(tab, tab);
            switch (tab) {
                case "f,ff":
                case "m":
                case "mf,mm":
                case "tm2f,tf2m":
                    tabs.add(createTab(title, Streamate.NAIAD_URL + "/performers?domain=streamate.com&loggedInRec=1&boostedFilters=&country=US&language=en&index=default&filters=gender:" + tab + "%3Bonline:true"));
                    break;
                case "fn":
                    tabs.add(createTab("Girls New", Streamate.NAIAD_URL + "/performers?domain=streamate.com&loggedInRec=1&boostedFilters=&country=US&language=en&index=default&filters=gender:f,ff%3Bonline:true%3Bnew:true"));
                    break;
                case "new":
                    tabs.add(createTab("New", Streamate.NAIAD_URL + "/performers?domain=streamate.com&loggedInRec=1&boostedFilters=&country=US&language=en&index=default&filters=new:true%3Bonline:true"));
                    break;
                default:
            }

        }

        followedTab = new StreamateFollowedTab((Streamate) site);
        followedTab.setRecorder(recorder);
        tabs.add(followedTab);

        return tabs;
    }

    @Override
    public Tab getFollowedTab() {
        return followedTab;
    }

    private Tab createTab(String title, String url) {
        var updateService = new StreamateUpdateService((Streamate) site, url);
        var tab = new StreamateTab(title, updateService, site);
        tab.setRecorder(recorder);
        return tab;
    }

    private List<String> getEnabledTabs() {
        return new ArrayList<>(Config.getInstance().getSettings().streamateTabs);
    }

}
