package ctbrec.ui.sites.xlovecam;

import ctbrec.Config;
import ctbrec.sites.xlovecam.XloveCam;
import ctbrec.ui.sites.AbstractTabProvider;
import ctbrec.ui.tabs.PaginatedScheduledService;
import ctbrec.ui.tabs.ThumbOverviewTab;
import javafx.scene.Scene;
import javafx.scene.control.Tab;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
// import java.util.Objects;

public class XloveCamTabProvider extends AbstractTabProvider {

    private final XloveCam xloveCam;

    private static final String FILTER_PARAM = "config[filter][10][]";
    private static final String FILTER_PARAM_NEW = "config[filter][100522][]";

    public XloveCamTabProvider(XloveCam xloveCam) {
        super(xloveCam);
        this.xloveCam = xloveCam;
    }

    @Override
    protected List<Tab> getSiteTabs(Scene scene) {
        List<Tab> tabs = new ArrayList<>();

        // all
        var updateService = new XloveCamUpdateService(xloveCam, Collections.emptyMap());
        tabs.add(createTab("All", updateService));

        // new
        updateService = new XloveCamUpdateService(xloveCam, Map.of(FILTER_PARAM_NEW, "3"));
        tabs.add(createTab("New", updateService));

        Map<String, String> tabMap = new HashMap<>();
        tabMap.put("1", "Young Women");
        tabMap.put("13", "Ladies");
        tabMap.put("6", "Mature Female");
        tabMap.put("2", "Couples");
        tabMap.put("3", "Lesbian");
        tabMap.put("7", "Male");
        tabMap.put("5", "Trans");
        List<String> enabledTabs = getEnabledTabs();
        for (String tab : enabledTabs) {
            String title = tabMap.getOrDefault(tab, tab);
            updateService = new XloveCamUpdateService(xloveCam, Map.of(FILTER_PARAM, tab));
            tabs.add(createTab(title, updateService));
        }

        return tabs;
    }

    private Tab createTab(String title, PaginatedScheduledService updateService) {
        var tab = new ThumbOverviewTab(title, updateService, xloveCam);
        tab.setRecorder(recorder);
        return tab;
    }

    private List<String> getEnabledTabs() {
        return new ArrayList<>(Config.getInstance().getSettings().xlovecamTabs);
    }

}
